<template>
  <div class="sw-gs-pagination" v-if="totalCount">
    <SwButton class="sw-gs-pagination-prev-btn color-transparent is-circle"
              :class="{'is-disabled--button': prevBtnDisabled}"
              :disabled="prevBtnDisabled"
              :title="$t('Go to previous page')"
              @click="navigateToPrevSlide">
      <SwGsIconChevronLeft class="color-dark-secondary size-sm"/>
    </SwButton>

    <div v-if="totalCount" class="sw-gs-pagination-page-overview">
      {{ currentSlideIndex }}/{{ totalCount }}
    </div>

    <SwButton class="sw-gs-pagination-next-btn color-transparent is-circle"
              :class="{'is-disabled--button': nextBtnDisabled}"
              :disabled="nextBtnDisabled"
              :title="$t('Go to next page')"
              @click="navigateToNextSlide">
      <SwGsIconChevronRight class="color-dark-secondary size-sm"/>
    </SwButton>
  </div>
</template>

<script lang="ts">
  import SwButton from "@/components/atoms/SwButton.vue";
  import { computed } from "@vue/composition-api";
  import { usePresentation } from "../../logic/composables/usePresentation";
  import { SwGsIconChevronLeft, SwGsIconChevronRight } from "../icons";
  import { useUIState } from "@shopware-pwa/composables";
  import { useInstantListing } from "../../logic/composables/useInstantListing";

  export default {
    name: 'SwGsPagination',
    components: {
      SwButton,
      SwGsIconChevronLeft,
      SwGsIconChevronRight
    },
    setup() {
      const { switchState: togglePageList } = useUIState({ stateName: "GS_NAVIGATION_PAGE_LIST_STATE" });
      const { totalCount, currentSlideIndex, goToPreviousSlide, goToNextSlide } = usePresentation();
      const { closeInstantListing } = useInstantListing();

      const prevBtnDisabled = computed(() => currentSlideIndex.value === 1);
      const nextBtnDisabled = computed(() => currentSlideIndex.value === totalCount.value);

      const navigateToPrevSlide = () => {
        goToPreviousSlide();
        togglePageList(false);
        closeInstantListing();
      };

      const navigateToNextSlide = () => {
        goToNextSlide();
        togglePageList(false);
        closeInstantListing();
      };

      return {
        currentSlideIndex,
        navigateToPrevSlide,
        navigateToNextSlide,
        totalCount,
        prevBtnDisabled,
        nextBtnDisabled
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-pagination {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
  }

  .sw-gs-pagination-prev-btn {
    margin-right: var(--spacer-xs);
  }

  .sw-gs-pagination-page-overview {
    padding: var(--spacer-xs) 0;
  }

  .sw-gs-pagination-next-btn {
    margin-left: var(--spacer-xs);
  }

  .is-disabled--button {
    ::v-deep .sf-icon {
      --icon-color: var(--c-gray-variant);
    }
  }
</style>
